# Path helper because Linux and Windows Paths are written differently
from pathlib import Path

# Bill specific Config
OUTPUT_MONTH = 3  # -1 for last Month
OUTPUT_YEAR = 2022  # -1 for current year
OUTPUT_CUSTOMER = 'Bentomax'

# User specific Parameter (COMMENT/UNCOMMENT USER AND SYSTEM)

# Danny Config
# USER = 'Danny'
# SYSTEM = USER + ''

# Nokko Config
USER = 'Nokko'
# SYSTEM = USER + 'Windows'
SYSTEM = USER + 'Ubuntu'

GLOBAL_TOOLS_DIR_PATH = {
    'Danny': Path("C:/Users/Danny/Desktop/EnD and Investment/Tools/"),
    'NokkoUbuntu': Path('/home/nokko/Dokumente/Business/EnD/Python/Tools/'),
    'NokkoWindows': Path("E:/Business/END/PythonProjekte/Tools/")
}
WORKTIME_TABLE_PATH = GLOBAL_TOOLS_DIR_PATH[SYSTEM] / Path('time_recoder/time_recorded_tables/')

WORKTIME_TABLE_NAME = {
    'Danny': 'work_time_danny.xlsx',
    'NokkoUbuntu': 'nokko_ubuntu.xlsx',
    'NokkoWindows': 'nokko_windows.xlsx'
}

OVERTIME_TABLE_NAME = {
    'Danny': 'overtime_danny.xlsx',
    'Nokko': 'overtime_nokko.xlsx'
}

# Docx Builder
DOCX_INPUT_PATH = GLOBAL_TOOLS_DIR_PATH[SYSTEM] / Path('fast_excel_to_bill/test_folder/Templates/templeta.docx')
LIST_OF_KEYS = ['Arbeitszeit', 'Task']
ROUND_TIME = 60

SAVE_OVERTIME_IN_TABLE = WORKTIME_TABLE_PATH / OVERTIME_TABLE_NAME[USER]

docx_output_dir_path = GLOBAL_TOOLS_DIR_PATH[SYSTEM] / Path('fast_excel_to_bill/test_folder/') # Variable cuz search of dir of customer can be implemeted
list_of_place_holders = ['?Netto?','?zzgl.?', '?gesamt?', 'insertdate'] # variable cuz search can be implemented

# Burden Date
payment_request_range = 30 # variable cuz customer contract data can be found
income_per_hour = 28  # variable cuz search of employee core data

FIRST_TABLE_KEYS = ['KW', 'Zeit in Stunden', 'Betrag in Euro']
NUMBER_OF_COLUMNS_FIRST_TABLE = len(FIRST_TABLE_KEYS)

SECOND_TABLE_KEYS = ['KW', 'Leistungsübersicht']
NUMBER_OF_COLUMNS_SECOND_TABLE = len(SECOND_TABLE_KEYS) # variable cuz searching of number of columns can be done



# Excel Pathes
employee_worktime_table_pathes = [#WORKTIME_TABLE_PATH / WORKTIME_TABLE_NAME['Danny'],
                                  WORKTIME_TABLE_PATH / WORKTIME_TABLE_NAME['NokkoUbuntu'],
                                  WORKTIME_TABLE_PATH / WORKTIME_TABLE_NAME['NokkoWindows']] # Variable cuz search of dir of tables can be implemented
